# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import re  # noqa: F401
import io
import warnings

from pydantic import validate_arguments, ValidationError

from typing_extensions import Annotated
from datetime import datetime

from pydantic import Field, StrictBool, StrictInt, StrictStr

from typing import List, Optional

from redrover_api.models.ok_result import OkResult
from redrover_api.models.vacancy_create_request import VacancyCreateRequest
from redrover_api.models.vacancy_detail_search_response import VacancyDetailSearchResponse
from redrover_api.models.vacancy_response import VacancyResponse

from redrover_api.api_client import ApiClient
from redrover_api.api_response import ApiResponse
from redrover_api.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class VacancyApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_arguments
    def delete_vacancy(self, org_id : Annotated[StrictInt, Field(..., description="The Red Rover Id of the Organization")], identifier : Annotated[StrictStr, Field(..., description="The identifier of the Vacancy. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`)")], **kwargs) -> OkResult:  # noqa: E501
        """Delete Vacancy By Id  # noqa: E501

        Delete specific Vacancy by it's identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_vacancy(org_id, identifier, async_req=True)
        >>> result = thread.get()

        :param org_id: The Red Rover Id of the Organization (required)
        :type org_id: int
        :param identifier: The identifier of the Vacancy. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`) (required)
        :type identifier: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: OkResult
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the delete_vacancy_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.delete_vacancy_with_http_info(org_id, identifier, **kwargs)  # noqa: E501

    @validate_arguments
    def delete_vacancy_with_http_info(self, org_id : Annotated[StrictInt, Field(..., description="The Red Rover Id of the Organization")], identifier : Annotated[StrictStr, Field(..., description="The identifier of the Vacancy. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`)")], **kwargs) -> ApiResponse:  # noqa: E501
        """Delete Vacancy By Id  # noqa: E501

        Delete specific Vacancy by it's identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_vacancy_with_http_info(org_id, identifier, async_req=True)
        >>> result = thread.get()

        :param org_id: The Red Rover Id of the Organization (required)
        :type org_id: int
        :param identifier: The identifier of the Vacancy. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`) (required)
        :type identifier: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(OkResult, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'org_id',
            'identifier'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_vacancy" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['org_id'] is not None:
            _path_params['orgId'] = _params['org_id']

        if _params['identifier'] is not None:
            _path_params['identifier'] = _params['identifier']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['apiKey']  # noqa: E501

        _response_types_map = {
            '200': "OkResult",
            '404': "NotFoundResult",
            '401': None,
        }

        return self.api_client.call_api(
            '/api/v1/{orgId}/Vacancy/{identifier}', 'DELETE',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def get_vacancy(self, org_id : Annotated[StrictInt, Field(..., description="The Red Rover Id of the Organization")], identifier : Annotated[StrictStr, Field(..., description="The identifier of the Vacancy. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`)")], **kwargs) -> VacancyResponse:  # noqa: E501
        """Get Vacancy By Id  # noqa: E501

        Get a specific Vacancy by it's identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_vacancy(org_id, identifier, async_req=True)
        >>> result = thread.get()

        :param org_id: The Red Rover Id of the Organization (required)
        :type org_id: int
        :param identifier: The identifier of the Vacancy. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`) (required)
        :type identifier: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: VacancyResponse
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the get_vacancy_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.get_vacancy_with_http_info(org_id, identifier, **kwargs)  # noqa: E501

    @validate_arguments
    def get_vacancy_with_http_info(self, org_id : Annotated[StrictInt, Field(..., description="The Red Rover Id of the Organization")], identifier : Annotated[StrictStr, Field(..., description="The identifier of the Vacancy. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`)")], **kwargs) -> ApiResponse:  # noqa: E501
        """Get Vacancy By Id  # noqa: E501

        Get a specific Vacancy by it's identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_vacancy_with_http_info(org_id, identifier, async_req=True)
        >>> result = thread.get()

        :param org_id: The Red Rover Id of the Organization (required)
        :type org_id: int
        :param identifier: The identifier of the Vacancy. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`) (required)
        :type identifier: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(VacancyResponse, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'org_id',
            'identifier'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_vacancy" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['org_id'] is not None:
            _path_params['orgId'] = _params['org_id']

        if _params['identifier'] is not None:
            _path_params['identifier'] = _params['identifier']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['apiKey']  # noqa: E501

        _response_types_map = {
            '200': "VacancyResponse",
            '404': "BadRequestResult",
            '401': None,
        }

        return self.api_client.call_api(
            '/api/v1/{orgId}/Vacancy/{identifier}', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def get_vacancy_details(self, org_id : Annotated[StrictInt, Field(..., description="The Red Rover Id of the Organization")], from_date : Annotated[datetime, Field(..., description="From date to filter Vacancies")], to_date : Annotated[datetime, Field(..., description="From date to filter Vacancies")], api_key : Optional[StrictStr] = None, verified : Annotated[Optional[StrictBool], Field(description="If a Vacancy has been verified")] = None, filled : Annotated[Optional[StrictBool], Field(description="If a Vacancy has been filled")] = None, substitute_source_org_id : Optional[StrictInt] = None, limit : Annotated[Optional[StrictInt], Field(description="Numerical limit of results returned")] = None, offset : Annotated[Optional[StrictInt], Field(description="Offset of results returned")] = None, include_deleted : Optional[StrictBool] = None, **kwargs) -> List[VacancyDetailSearchResponse]:  # noqa: E501
        """ Query Vacancy Details  # noqa: E501

        Query for Vacancy Details based on specified search criteria  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_vacancy_details(org_id, from_date, to_date, api_key, verified, filled, substitute_source_org_id, limit, offset, include_deleted, async_req=True)
        >>> result = thread.get()

        :param org_id: The Red Rover Id of the Organization (required)
        :type org_id: int
        :param from_date: From date to filter Vacancies (required)
        :type from_date: datetime
        :param to_date: From date to filter Vacancies (required)
        :type to_date: datetime
        :param api_key:
        :type api_key: str
        :param verified: If a Vacancy has been verified
        :type verified: bool
        :param filled: If a Vacancy has been filled
        :type filled: bool
        :param substitute_source_org_id: 
        :type substitute_source_org_id: int
        :param limit: Numerical limit of results returned
        :type limit: int
        :param offset: Offset of results returned
        :type offset: int
        :param include_deleted:
        :type include_deleted: bool
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: List[VacancyDetailSearchResponse]
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the get_vacancy_details_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.get_vacancy_details_with_http_info(org_id, from_date, to_date, api_key, verified, filled, substitute_source_org_id, limit, offset, include_deleted, **kwargs)  # noqa: E501

    @validate_arguments
    def get_vacancy_details_with_http_info(self, org_id : Annotated[StrictInt, Field(..., description="The Red Rover Id of the Organization")], from_date : Annotated[datetime, Field(..., description="From date to filter Vacancies")], to_date : Annotated[datetime, Field(..., description="From date to filter Vacancies")], api_key : Optional[StrictStr] = None, verified : Annotated[Optional[StrictBool], Field(description="If a Vacancy has been verified")] = None, filled : Annotated[Optional[StrictBool], Field(description="If a Vacancy has been filled")] = None, substitute_source_org_id : Optional[StrictInt] = None, limit : Annotated[Optional[StrictInt], Field(description="Numerical limit of results returned")] = None, offset : Annotated[Optional[StrictInt], Field(description="Offset of results returned")] = None, include_deleted : Optional[StrictBool] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """ Query Vacancy Details  # noqa: E501

        Query for Vacancy Details based on specified search criteria  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_vacancy_details_with_http_info(org_id, from_date, to_date, api_key, verified, filled, substitute_source_org_id, limit, offset, include_deleted, async_req=True)
        >>> result = thread.get()

        :param org_id: The Red Rover Id of the Organization (required)
        :type org_id: int
        :param from_date: From date to filter Vacancies (required)
        :type from_date: datetime
        :param to_date: From date to filter Vacancies (required)
        :type to_date: datetime
        :param api_key:
        :type api_key: str
        :param verified: If a Vacancy has been verified
        :type verified: bool
        :param filled: If a Vacancy has been filled
        :type filled: bool
        :param substitute_source_org_id: 
        :type substitute_source_org_id: int
        :param limit: Numerical limit of results returned
        :type limit: int
        :param offset: Offset of results returned
        :type offset: int
        :param include_deleted:
        :type include_deleted: bool
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(List[VacancyDetailSearchResponse], status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'org_id',
            'from_date',
            'to_date',
            'api_key',
            'verified',
            'filled',
            'substitute_source_org_id',
            'limit',
            'offset',
            'include_deleted'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_vacancy_details" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['org_id'] is not None:
            _path_params['orgId'] = _params['org_id']


        # process the query parameters
        _query_params = []
        if _params.get('from_date') is not None:  # noqa: E501
            if isinstance(_params['from_date'], datetime):
                _query_params.append(('fromDate', _params['from_date'].strftime(self.api_client.configuration.datetime_format)))
            else:
                _query_params.append(('fromDate', _params['from_date']))

        if _params.get('to_date') is not None:  # noqa: E501
            if isinstance(_params['to_date'], datetime):
                _query_params.append(('toDate', _params['to_date'].strftime(self.api_client.configuration.datetime_format)))
            else:
                _query_params.append(('toDate', _params['to_date']))

        if _params.get('verified') is not None:  # noqa: E501
            _query_params.append(('verified', _params['verified']))

        if _params.get('filled') is not None:  # noqa: E501
            _query_params.append(('filled', _params['filled']))

        if _params.get('substitute_source_org_id') is not None:  # noqa: E501
            _query_params.append(('substituteSourceOrgId', _params['substitute_source_org_id']))

        if _params.get('limit') is not None:  # noqa: E501
            _query_params.append(('limit', _params['limit']))

        if _params.get('offset') is not None:  # noqa: E501
            _query_params.append(('offset', _params['offset']))

        if _params.get('include_deleted') is not None:  # noqa: E501
            _query_params.append(('includeDeleted', _params['include_deleted']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['api_key'] is not None:
            _header_params['apiKey'] = _params['api_key']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['apiKey']  # noqa: E501

        _response_types_map = {
            '200': "List[VacancyDetailSearchResponse]",
            '400': "BadRequestResult",
            '401': None,
        }

        return self.api_client.call_api(
            '/api/v1/{orgId}/Vacancy/vacancyDetails', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def post_vacancy(self, org_id : Annotated[StrictInt, Field(..., description="The Red Rover Id of the Organization")], vacancy_create_request : Annotated[VacancyCreateRequest, Field(..., description="The details of the Vacancy")], **kwargs) -> VacancyResponse:  # noqa: E501
        """Create a Vacancy  # noqa: E501

        Create a Vacancy  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.post_vacancy(org_id, vacancy_create_request, async_req=True)
        >>> result = thread.get()

        :param org_id: The Red Rover Id of the Organization (required)
        :type org_id: int
        :param vacancy_create_request: The details of the Vacancy (required)
        :type vacancy_create_request: VacancyCreateRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: VacancyResponse
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the post_vacancy_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.post_vacancy_with_http_info(org_id, vacancy_create_request, **kwargs)  # noqa: E501

    @validate_arguments
    def post_vacancy_with_http_info(self, org_id : Annotated[StrictInt, Field(..., description="The Red Rover Id of the Organization")], vacancy_create_request : Annotated[VacancyCreateRequest, Field(..., description="The details of the Vacancy")], **kwargs) -> ApiResponse:  # noqa: E501
        """Create a Vacancy  # noqa: E501

        Create a Vacancy  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.post_vacancy_with_http_info(org_id, vacancy_create_request, async_req=True)
        >>> result = thread.get()

        :param org_id: The Red Rover Id of the Organization (required)
        :type org_id: int
        :param vacancy_create_request: The details of the Vacancy (required)
        :type vacancy_create_request: VacancyCreateRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(VacancyResponse, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'org_id',
            'vacancy_create_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_vacancy" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['org_id'] is not None:
            _path_params['orgId'] = _params['org_id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['vacancy_create_request'] is not None:
            _body_params = _params['vacancy_create_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['apiKey']  # noqa: E501

        _response_types_map = {
            '200': "VacancyResponse",
            '401': None,
        }

        return self.api_client.call_api(
            '/api/v1/{orgId}/Vacancy', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
