# coding: utf-8

# flake8: noqa
"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


# import models into model package
from redrover_api.models.absence_create_request import AbsenceCreateRequest
from redrover_api.models.absence_detail_create_request import AbsenceDetailCreateRequest
from redrover_api.models.absence_detail_response import AbsenceDetailResponse
from redrover_api.models.absence_reason_balance_create_request import AbsenceReasonBalanceCreateRequest
from redrover_api.models.absence_reason_balance_response import AbsenceReasonBalanceResponse
from redrover_api.models.absence_reason_balance_update_request import AbsenceReasonBalanceUpdateRequest
from redrover_api.models.absence_reason_category_response import AbsenceReasonCategoryResponse
from redrover_api.models.absence_reason_response import AbsenceReasonResponse
from redrover_api.models.absence_reason_tracking_type_enum import AbsenceReasonTrackingTypeEnum
from redrover_api.models.absence_reason_usage_create_request import AbsenceReasonUsageCreateRequest
from redrover_api.models.absence_reason_usage_response import AbsenceReasonUsageResponse
from redrover_api.models.absence_response import AbsenceResponse
from redrover_api.models.absence_update_request import AbsenceUpdateRequest
from redrover_api.models.absence_vacancy_detail_request import AbsenceVacancyDetailRequest
from redrover_api.models.absence_vacancy_request import AbsenceVacancyRequest
from redrover_api.models.access_control_request import AccessControlRequest
from redrover_api.models.access_control_response import AccessControlResponse
from redrover_api.models.accounting_code_allocation_request import AccountingCodeAllocationRequest
from redrover_api.models.accounting_code_allocation_response import AccountingCodeAllocationResponse
from redrover_api.models.accounting_code_light_response import AccountingCodeLightResponse
from redrover_api.models.administrator_request import AdministratorRequest
from redrover_api.models.administrator_response import AdministratorResponse
from redrover_api.models.approval_status_enum import ApprovalStatusEnum
from redrover_api.models.assignment_response import AssignmentResponse
from redrover_api.models.attribute_request import AttributeRequest
from redrover_api.models.attribute_response import AttributeResponse
from redrover_api.models.authentication_properties import AuthenticationProperties
from redrover_api.models.bad_request_result import BadRequestResult
from redrover_api.models.contract_light_response import ContractLightResponse
from redrover_api.models.country_enum import CountryEnum
from redrover_api.models.day_of_week import DayOfWeek
from redrover_api.models.day_part_enum import DayPartEnum
from redrover_api.models.employee_request import EmployeeRequest
from redrover_api.models.employee_response import EmployeeResponse
from redrover_api.models.file_format import FileFormat
from redrover_api.models.fill_status_enum import FillStatusEnum
from redrover_api.models.forbid_result import ForbidResult
from redrover_api.models.int32_id_name_class import Int32IdNameClass
from redrover_api.models.int32_locator_request import Int32LocatorRequest
from redrover_api.models.int32_locator_response import Int32LocatorResponse
from redrover_api.models.needs_replacement_enum import NeedsReplacementEnum
from redrover_api.models.not_found_result import NotFoundResult
from redrover_api.models.ok_object_result import OkObjectResult
from redrover_api.models.ok_result import OkResult
from redrover_api.models.org_user_employee_response import OrgUserEmployeeResponse
from redrover_api.models.organization_response import OrganizationResponse
from redrover_api.models.pay_code_create_request import PayCodeCreateRequest
from redrover_api.models.pay_code_response import PayCodeResponse
from redrover_api.models.pay_code_update_request import PayCodeUpdateRequest
from redrover_api.models.position_job_request import PositionJobRequest
from redrover_api.models.position_request import PositionRequest
from redrover_api.models.position_response import PositionResponse
from redrover_api.models.position_schedule_custom_variant_request import PositionScheduleCustomVariantRequest
from redrover_api.models.position_schedule_item_request import PositionScheduleItemRequest
from redrover_api.models.position_schedule_mode_enum import PositionScheduleModeEnum
from redrover_api.models.position_schedule_request import PositionScheduleRequest
from redrover_api.models.reason import Reason
from redrover_api.models.school_year_response import SchoolYearResponse
from redrover_api.models.simple_absence_detail import SimpleAbsenceDetail
from redrover_api.models.simple_person import SimplePerson
from redrover_api.models.simple_position import SimplePosition
from redrover_api.models.simple_position_response import SimplePositionResponse
from redrover_api.models.state_enum import StateEnum
from redrover_api.models.substitute_attribute_request import SubstituteAttributeRequest
from redrover_api.models.substitute_attribute_response import SubstituteAttributeResponse
from redrover_api.models.substitute_preferences_request import SubstitutePreferencesRequest
from redrover_api.models.substitute_related_org_request import SubstituteRelatedOrgRequest
from redrover_api.models.substitute_request import SubstituteRequest
from redrover_api.models.substitute_response import SubstituteResponse
from redrover_api.models.time_off_balance_request import TimeOffBalanceRequest
from redrover_api.models.user_roles import UserRoles
from redrover_api.models.vacancy_accounting_code_allocation_request import VacancyAccountingCodeAllocationRequest
from redrover_api.models.vacancy_create_request import VacancyCreateRequest
from redrover_api.models.vacancy_detail_create_request import VacancyDetailCreateRequest
from redrover_api.models.vacancy_detail_response import VacancyDetailResponse
from redrover_api.models.vacancy_detail_search_response import VacancyDetailSearchResponse
from redrover_api.models.vacancy_response import VacancyResponse
from redrover_api.models.webhook_create_request import WebhookCreateRequest
from redrover_api.models.webhook_response import WebhookResponse
from redrover_api.models.webhook_update_request import WebhookUpdateRequest
