# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from redrover_api.models.absence_reason_usage_create_request import AbsenceReasonUsageCreateRequest
from redrover_api.models.day_part_enum import DayPartEnum

class AbsenceDetailCreateRequest(BaseModel):
    """
    Absences are broken up into individual components called AbsenceDetails. Each AbsenceDetail is contained within one date. An absence can have many AbsenceDetails associated with it  # noqa: E501
    """
    var_date: datetime = Field(..., alias="date", description="The Date of the AbsenceDetail")
    day_part: DayPartEnum = Field(..., alias="dayPart")
    description: Optional[StrictStr] = None
    start_time: datetime = Field(..., alias="startTime", description="The start time of the AbsenceDetail")
    end_time: datetime = Field(..., alias="endTime", description="The start time of the AbsenceDetail")
    reasons: conlist(AbsenceReasonUsageCreateRequest) = Field(..., description="The Reasons for absence in this AbsenceDetail")
    __properties = ["date", "dayPart", "description", "startTime", "endTime", "reasons"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AbsenceDetailCreateRequest:
        """Create an instance of AbsenceDetailCreateRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in reasons (list)
        _items = []
        if self.reasons:
            for _item in self.reasons:
                if _item:
                    _items.append(_item.to_dict())
            _dict['reasons'] = _items
        # set to None if description (nullable) is None
        # and __fields_set__ contains the field
        if self.description is None and "description" in self.__fields_set__:
            _dict['description'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AbsenceDetailCreateRequest:
        """Create an instance of AbsenceDetailCreateRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AbsenceDetailCreateRequest.parse_obj(obj)

        _obj = AbsenceDetailCreateRequest.parse_obj({
            "var_date": obj.get("date"),
            "day_part": obj.get("dayPart"),
            "description": obj.get("description"),
            "start_time": obj.get("startTime"),
            "end_time": obj.get("endTime"),
            "reasons": [AbsenceReasonUsageCreateRequest.from_dict(_item) for _item in obj.get("reasons")] if obj.get("reasons") is not None else None
        })
        return _obj


