# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt
from redrover_api.models.absence_reason_tracking_type_enum import AbsenceReasonTrackingTypeEnum

class AbsenceReasonBalanceResponse(BaseModel):
    """
    AbsenceReasonBalanceResponse
    """
    id: Optional[StrictInt] = Field(None, description="The Red Rover internal Id of AbsenceReasonBalance (numeric)")
    employee_id: Optional[StrictInt] = Field(None, alias="employeeId", description="The Red Rover internal Id of Employee (numeric)")
    school_year_id: Optional[StrictInt] = Field(None, alias="schoolYearId", description="The Red Rover internal Id of SchoolYear (numeric)")
    absence_reason_id: Optional[StrictInt] = Field(None, alias="absenceReasonId", description="The Red Rover internal Id of AbsenceReason (numeric)")
    absence_reason_category_id: Optional[StrictInt] = Field(None, alias="absenceReasonCategoryId", description="The Red Rover internal Id of AbsenceReasonCategory (numeric)")
    balance_as_of: Optional[datetime] = Field(None, alias="balanceAsOf", description="The 'As of' date as to when this balance was last update")
    initial_balance: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="initialBalance", description="How much the employee initially had")
    used_balance: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="usedBalance", description="How much has been used")
    unused_balance: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="unusedBalance", description="How much has not been used")
    earned_balance: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="earnedBalance", description="The amount of balance that was earned")
    net_balance: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="netBalance", description="The net balance")
    used_balance_calculated_at_utc: Optional[datetime] = Field(None, alias="usedBalanceCalculatedAtUtc", description="When the last time that the 'used' balance was calculated")
    absence_reason_tracking_type: Optional[AbsenceReasonTrackingTypeEnum] = Field(None, alias="absenceReasonTrackingType")
    __properties = ["id", "employeeId", "schoolYearId", "absenceReasonId", "absenceReasonCategoryId", "balanceAsOf", "initialBalance", "usedBalance", "unusedBalance", "earnedBalance", "netBalance", "usedBalanceCalculatedAtUtc", "absenceReasonTrackingType"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AbsenceReasonBalanceResponse:
        """Create an instance of AbsenceReasonBalanceResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if absence_reason_id (nullable) is None
        # and __fields_set__ contains the field
        if self.absence_reason_id is None and "absence_reason_id" in self.__fields_set__:
            _dict['absenceReasonId'] = None

        # set to None if absence_reason_category_id (nullable) is None
        # and __fields_set__ contains the field
        if self.absence_reason_category_id is None and "absence_reason_category_id" in self.__fields_set__:
            _dict['absenceReasonCategoryId'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AbsenceReasonBalanceResponse:
        """Create an instance of AbsenceReasonBalanceResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AbsenceReasonBalanceResponse.parse_obj(obj)

        _obj = AbsenceReasonBalanceResponse.parse_obj({
            "id": obj.get("id"),
            "employee_id": obj.get("employeeId"),
            "school_year_id": obj.get("schoolYearId"),
            "absence_reason_id": obj.get("absenceReasonId"),
            "absence_reason_category_id": obj.get("absenceReasonCategoryId"),
            "balance_as_of": obj.get("balanceAsOf"),
            "initial_balance": obj.get("initialBalance"),
            "used_balance": obj.get("usedBalance"),
            "unused_balance": obj.get("unusedBalance"),
            "earned_balance": obj.get("earnedBalance"),
            "net_balance": obj.get("netBalance"),
            "used_balance_calculated_at_utc": obj.get("usedBalanceCalculatedAtUtc"),
            "absence_reason_tracking_type": obj.get("absenceReasonTrackingType")
        })
        return _obj


