# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist
from redrover_api.models.absence_reason_category_response import AbsenceReasonCategoryResponse

class AbsenceReasonResponse(BaseModel):
    """
    AbsenceReasonResponse
    """
    id: Optional[StrictInt] = Field(None, description="The Red Rover internal Id of AbsenceReason (numeric)")
    external_id: Optional[StrictStr] = Field(None, alias="externalId", description="The external Id of AbsenceReason (alpha-numeric)")
    allow_negative_balance: Optional[StrictBool] = Field(None, alias="allowNegativeBalance", description="If negative balances are allowed for this Absence Reason")
    name: Optional[StrictStr] = Field(None, description="The Absence Reason's name")
    description: Optional[StrictStr] = Field(None, description="A detailed description of the Absence Reason")
    category: Optional[AbsenceReasonCategoryResponse] = None
    requires_notes_to_admin: Optional[StrictBool] = Field(None, alias="requiresNotesToAdmin", description="If this Absence Reason requires a note to the Administrator")
    requires_approval: Optional[StrictBool] = Field(None, alias="requiresApproval", description="If this Absence Reason requires an approval")
    code: Optional[StrictStr] = Field(None, description="The 'Code' assigned to this Absence Reason. For external purposes")
    position_type_ids: Optional[conlist(StrictInt)] = Field(None, alias="positionTypeIds", description="Position Type Ids that are associated with this Absence Reason")
    contract_ids: Optional[conlist(StrictInt)] = Field(None, alias="contractIds", description="Contract Ids that are associated with this Absence Reason")
    __properties = ["id", "externalId", "allowNegativeBalance", "name", "description", "category", "requiresNotesToAdmin", "requiresApproval", "code", "positionTypeIds", "contractIds"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AbsenceReasonResponse:
        """Create an instance of AbsenceReasonResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of category
        if self.category:
            _dict['category'] = self.category.to_dict()
        # set to None if external_id (nullable) is None
        # and __fields_set__ contains the field
        if self.external_id is None and "external_id" in self.__fields_set__:
            _dict['externalId'] = None

        # set to None if name (nullable) is None
        # and __fields_set__ contains the field
        if self.name is None and "name" in self.__fields_set__:
            _dict['name'] = None

        # set to None if description (nullable) is None
        # and __fields_set__ contains the field
        if self.description is None and "description" in self.__fields_set__:
            _dict['description'] = None

        # set to None if requires_notes_to_admin (nullable) is None
        # and __fields_set__ contains the field
        if self.requires_notes_to_admin is None and "requires_notes_to_admin" in self.__fields_set__:
            _dict['requiresNotesToAdmin'] = None

        # set to None if code (nullable) is None
        # and __fields_set__ contains the field
        if self.code is None and "code" in self.__fields_set__:
            _dict['code'] = None

        # set to None if position_type_ids (nullable) is None
        # and __fields_set__ contains the field
        if self.position_type_ids is None and "position_type_ids" in self.__fields_set__:
            _dict['positionTypeIds'] = None

        # set to None if contract_ids (nullable) is None
        # and __fields_set__ contains the field
        if self.contract_ids is None and "contract_ids" in self.__fields_set__:
            _dict['contractIds'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AbsenceReasonResponse:
        """Create an instance of AbsenceReasonResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AbsenceReasonResponse.parse_obj(obj)

        _obj = AbsenceReasonResponse.parse_obj({
            "id": obj.get("id"),
            "external_id": obj.get("externalId"),
            "allow_negative_balance": obj.get("allowNegativeBalance"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "category": AbsenceReasonCategoryResponse.from_dict(obj.get("category")) if obj.get("category") is not None else None,
            "requires_notes_to_admin": obj.get("requiresNotesToAdmin"),
            "requires_approval": obj.get("requiresApproval"),
            "code": obj.get("code"),
            "position_type_ids": obj.get("positionTypeIds"),
            "contract_ids": obj.get("contractIds")
        })
        return _obj


