# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, conlist

class AccessControlResponse(BaseModel):
    """
    Access control levels of the user  # noqa: E501
    """
    all_locations: Optional[StrictBool] = Field(None, alias="allLocations", description="If the user has access to all locations")
    all_position_types: Optional[StrictBool] = Field(None, alias="allPositionTypes", description="If the user has access to all position types")
    location_ids: Optional[conlist(StrictInt)] = Field(None, alias="locationIds", description="The Ids of the Locations the user has access to")
    location_group_ids: Optional[conlist(StrictInt)] = Field(None, alias="locationGroupIds", description="The Ids of the Location Groups the user has access to")
    position_type_ids: Optional[conlist(StrictInt)] = Field(None, alias="positionTypeIds", description="The Ids of the Position Types the user has access to")
    __properties = ["allLocations", "allPositionTypes", "locationIds", "locationGroupIds", "positionTypeIds"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AccessControlResponse:
        """Create an instance of AccessControlResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if location_ids (nullable) is None
        # and __fields_set__ contains the field
        if self.location_ids is None and "location_ids" in self.__fields_set__:
            _dict['locationIds'] = None

        # set to None if location_group_ids (nullable) is None
        # and __fields_set__ contains the field
        if self.location_group_ids is None and "location_group_ids" in self.__fields_set__:
            _dict['locationGroupIds'] = None

        # set to None if position_type_ids (nullable) is None
        # and __fields_set__ contains the field
        if self.position_type_ids is None and "position_type_ids" in self.__fields_set__:
            _dict['positionTypeIds'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AccessControlResponse:
        """Create an instance of AccessControlResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AccessControlResponse.parse_obj(obj)

        _obj = AccessControlResponse.parse_obj({
            "all_locations": obj.get("allLocations"),
            "all_position_types": obj.get("allPositionTypes"),
            "location_ids": obj.get("locationIds"),
            "location_group_ids": obj.get("locationGroupIds"),
            "position_type_ids": obj.get("positionTypeIds")
        })
        return _obj


