# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist

class OkObjectResult(BaseModel):
    """
    OkObjectResult
    """
    value: Optional[Any] = None
    formatters: Optional[conlist(Dict[str, Any])] = None
    content_types: Optional[conlist(StrictStr)] = Field(None, alias="contentTypes")
    declared_type: Optional[StrictStr] = Field(None, alias="declaredType")
    status_code: Optional[StrictInt] = Field(None, alias="statusCode")
    __properties = ["value", "formatters", "contentTypes", "declaredType", "statusCode"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OkObjectResult:
        """Create an instance of OkObjectResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if value (nullable) is None
        # and __fields_set__ contains the field
        if self.value is None and "value" in self.__fields_set__:
            _dict['value'] = None

        # set to None if formatters (nullable) is None
        # and __fields_set__ contains the field
        if self.formatters is None and "formatters" in self.__fields_set__:
            _dict['formatters'] = None

        # set to None if content_types (nullable) is None
        # and __fields_set__ contains the field
        if self.content_types is None and "content_types" in self.__fields_set__:
            _dict['contentTypes'] = None

        # set to None if declared_type (nullable) is None
        # and __fields_set__ contains the field
        if self.declared_type is None and "declared_type" in self.__fields_set__:
            _dict['declaredType'] = None

        # set to None if status_code (nullable) is None
        # and __fields_set__ contains the field
        if self.status_code is None and "status_code" in self.__fields_set__:
            _dict['statusCode'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OkObjectResult:
        """Create an instance of OkObjectResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OkObjectResult.parse_obj(obj)

        _obj = OkObjectResult.parse_obj({
            "value": obj.get("value"),
            "formatters": obj.get("formatters"),
            "content_types": obj.get("contentTypes"),
            "declared_type": obj.get("declaredType"),
            "status_code": obj.get("statusCode")
        })
        return _obj


