# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class PayCodeResponse(BaseModel):
    """
    The Pay code of the Vacancy  # noqa: E501
    """
    code: Optional[StrictStr] = Field(None, description="The Code used")
    hourly_rate: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="hourlyRate", description="Hourly rate (decimal 7,2)")
    unit_rate: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="unitRate", description="Unit rate (decimal 7,2)")
    half_day_rate: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="halfDayRate", description="Half day rate (decimal 7,2)")
    full_day_rate: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="fullDayRate", description="Full day rate (decimal 7,2)")
    valid_until_utc: Optional[datetime] = Field(None, alias="validUntilUtc", description="When the pay code is valid until")
    name: Optional[StrictStr] = None
    id: Optional[StrictInt] = None
    external_id: Optional[StrictStr] = Field(None, alias="externalId")
    __properties = ["code", "hourlyRate", "unitRate", "halfDayRate", "fullDayRate", "validUntilUtc", "name", "id", "externalId"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PayCodeResponse:
        """Create an instance of PayCodeResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if code (nullable) is None
        # and __fields_set__ contains the field
        if self.code is None and "code" in self.__fields_set__:
            _dict['code'] = None

        # set to None if hourly_rate (nullable) is None
        # and __fields_set__ contains the field
        if self.hourly_rate is None and "hourly_rate" in self.__fields_set__:
            _dict['hourlyRate'] = None

        # set to None if unit_rate (nullable) is None
        # and __fields_set__ contains the field
        if self.unit_rate is None and "unit_rate" in self.__fields_set__:
            _dict['unitRate'] = None

        # set to None if half_day_rate (nullable) is None
        # and __fields_set__ contains the field
        if self.half_day_rate is None and "half_day_rate" in self.__fields_set__:
            _dict['halfDayRate'] = None

        # set to None if full_day_rate (nullable) is None
        # and __fields_set__ contains the field
        if self.full_day_rate is None and "full_day_rate" in self.__fields_set__:
            _dict['fullDayRate'] = None

        # set to None if name (nullable) is None
        # and __fields_set__ contains the field
        if self.name is None and "name" in self.__fields_set__:
            _dict['name'] = None

        # set to None if external_id (nullable) is None
        # and __fields_set__ contains the field
        if self.external_id is None and "external_id" in self.__fields_set__:
            _dict['externalId'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PayCodeResponse:
        """Create an instance of PayCodeResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PayCodeResponse.parse_obj(obj)

        _obj = PayCodeResponse.parse_obj({
            "code": obj.get("code"),
            "hourly_rate": obj.get("hourlyRate"),
            "unit_rate": obj.get("unitRate"),
            "half_day_rate": obj.get("halfDayRate"),
            "full_day_rate": obj.get("fullDayRate"),
            "valid_until_utc": obj.get("validUntilUtc"),
            "name": obj.get("name"),
            "id": obj.get("id"),
            "external_id": obj.get("externalId")
        })
        return _obj


