# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import List, Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, conlist
from redrover_api.models.accounting_code_allocation_request import AccountingCodeAllocationRequest
from redrover_api.models.int32_locator_request import Int32LocatorRequest

class PositionJobRequest(BaseModel):
    """
    PositionJobRequest
    """
    job: Optional[Int32LocatorRequest] = None
    pay_step: Optional[Int32LocatorRequest] = Field(None, alias="payStep")
    override_pay_rate: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="overridePayRate", description="The pay rate override")
    visible: Optional[StrictBool] = Field(None, description="If the Job is visible. (Default is true)")
    position_job_id: Optional[StrictInt] = Field(None, alias="positionJobId", description="The Position Job Id")
    effective_as_of: Optional[datetime] = Field(None, alias="effectiveAsOf", description="The effective date of ths Job")
    accounting_codes: Optional[conlist(AccountingCodeAllocationRequest)] = Field(None, alias="accountingCodes", description="Accounting code allocations")
    __properties = ["job", "payStep", "overridePayRate", "visible", "positionJobId", "effectiveAsOf", "accountingCodes"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PositionJobRequest:
        """Create an instance of PositionJobRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of job
        if self.job:
            _dict['job'] = self.job.to_dict()
        # override the default output from pydantic by calling `to_dict()` of pay_step
        if self.pay_step:
            _dict['payStep'] = self.pay_step.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in accounting_codes (list)
        _items = []
        if self.accounting_codes:
            for _item in self.accounting_codes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['accountingCodes'] = _items
        # set to None if override_pay_rate (nullable) is None
        # and __fields_set__ contains the field
        if self.override_pay_rate is None and "override_pay_rate" in self.__fields_set__:
            _dict['overridePayRate'] = None

        # set to None if position_job_id (nullable) is None
        # and __fields_set__ contains the field
        if self.position_job_id is None and "position_job_id" in self.__fields_set__:
            _dict['positionJobId'] = None

        # set to None if effective_as_of (nullable) is None
        # and __fields_set__ contains the field
        if self.effective_as_of is None and "effective_as_of" in self.__fields_set__:
            _dict['effectiveAsOf'] = None

        # set to None if accounting_codes (nullable) is None
        # and __fields_set__ contains the field
        if self.accounting_codes is None and "accounting_codes" in self.__fields_set__:
            _dict['accountingCodes'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PositionJobRequest:
        """Create an instance of PositionJobRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PositionJobRequest.parse_obj(obj)

        _obj = PositionJobRequest.parse_obj({
            "job": Int32LocatorRequest.from_dict(obj.get("job")) if obj.get("job") is not None else None,
            "pay_step": Int32LocatorRequest.from_dict(obj.get("payStep")) if obj.get("payStep") is not None else None,
            "override_pay_rate": obj.get("overridePayRate"),
            "visible": obj.get("visible"),
            "position_job_id": obj.get("positionJobId"),
            "effective_as_of": obj.get("effectiveAsOf"),
            "accounting_codes": [AccountingCodeAllocationRequest.from_dict(_item) for _item in obj.get("accountingCodes")] if obj.get("accountingCodes") is not None else None
        })
        return _obj


