# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, conlist
from redrover_api.models.accounting_code_allocation_request import AccountingCodeAllocationRequest
from redrover_api.models.int32_locator_request import Int32LocatorRequest
from redrover_api.models.position_schedule_custom_variant_request import PositionScheduleCustomVariantRequest

class PositionScheduleItemRequest(BaseModel):
    """
    PositionScheduleItemRequest
    """
    accounting_code_allocations: Optional[conlist(AccountingCodeAllocationRequest)] = Field(None, alias="accountingCodeAllocations", description="Accounting Code allocations")
    location: Int32LocatorRequest = Field(...)
    job: Optional[Int32LocatorRequest] = None
    bell_schedule: Int32LocatorRequest = Field(..., alias="bellSchedule")
    start_period: Optional[Int32LocatorRequest] = Field(None, alias="startPeriod")
    end_period: Optional[Int32LocatorRequest] = Field(None, alias="endPeriod")
    periods_not_needing_replacement: Optional[conlist(Int32LocatorRequest)] = Field(None, alias="periodsNotNeedingReplacement", description="The Periods that do not need replacement")
    standard_custom_schedule_variant: Optional[PositionScheduleCustomVariantRequest] = Field(None, alias="standardCustomScheduleVariant")
    additional_custom_schedule_variants: Optional[conlist(PositionScheduleCustomVariantRequest)] = Field(None, alias="additionalCustomScheduleVariants", description="Additional custom schedule variant")
    __properties = ["accountingCodeAllocations", "location", "job", "bellSchedule", "startPeriod", "endPeriod", "periodsNotNeedingReplacement", "standardCustomScheduleVariant", "additionalCustomScheduleVariants"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PositionScheduleItemRequest:
        """Create an instance of PositionScheduleItemRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in accounting_code_allocations (list)
        _items = []
        if self.accounting_code_allocations:
            for _item in self.accounting_code_allocations:
                if _item:
                    _items.append(_item.to_dict())
            _dict['accountingCodeAllocations'] = _items
        # override the default output from pydantic by calling `to_dict()` of location
        if self.location:
            _dict['location'] = self.location.to_dict()
        # override the default output from pydantic by calling `to_dict()` of job
        if self.job:
            _dict['job'] = self.job.to_dict()
        # override the default output from pydantic by calling `to_dict()` of bell_schedule
        if self.bell_schedule:
            _dict['bellSchedule'] = self.bell_schedule.to_dict()
        # override the default output from pydantic by calling `to_dict()` of start_period
        if self.start_period:
            _dict['startPeriod'] = self.start_period.to_dict()
        # override the default output from pydantic by calling `to_dict()` of end_period
        if self.end_period:
            _dict['endPeriod'] = self.end_period.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in periods_not_needing_replacement (list)
        _items = []
        if self.periods_not_needing_replacement:
            for _item in self.periods_not_needing_replacement:
                if _item:
                    _items.append(_item.to_dict())
            _dict['periodsNotNeedingReplacement'] = _items
        # override the default output from pydantic by calling `to_dict()` of standard_custom_schedule_variant
        if self.standard_custom_schedule_variant:
            _dict['standardCustomScheduleVariant'] = self.standard_custom_schedule_variant.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in additional_custom_schedule_variants (list)
        _items = []
        if self.additional_custom_schedule_variants:
            for _item in self.additional_custom_schedule_variants:
                if _item:
                    _items.append(_item.to_dict())
            _dict['additionalCustomScheduleVariants'] = _items
        # set to None if accounting_code_allocations (nullable) is None
        # and __fields_set__ contains the field
        if self.accounting_code_allocations is None and "accounting_code_allocations" in self.__fields_set__:
            _dict['accountingCodeAllocations'] = None

        # set to None if periods_not_needing_replacement (nullable) is None
        # and __fields_set__ contains the field
        if self.periods_not_needing_replacement is None and "periods_not_needing_replacement" in self.__fields_set__:
            _dict['periodsNotNeedingReplacement'] = None

        # set to None if additional_custom_schedule_variants (nullable) is None
        # and __fields_set__ contains the field
        if self.additional_custom_schedule_variants is None and "additional_custom_schedule_variants" in self.__fields_set__:
            _dict['additionalCustomScheduleVariants'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PositionScheduleItemRequest:
        """Create an instance of PositionScheduleItemRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PositionScheduleItemRequest.parse_obj(obj)

        _obj = PositionScheduleItemRequest.parse_obj({
            "accounting_code_allocations": [AccountingCodeAllocationRequest.from_dict(_item) for _item in obj.get("accountingCodeAllocations")] if obj.get("accountingCodeAllocations") is not None else None,
            "location": Int32LocatorRequest.from_dict(obj.get("location")) if obj.get("location") is not None else None,
            "job": Int32LocatorRequest.from_dict(obj.get("job")) if obj.get("job") is not None else None,
            "bell_schedule": Int32LocatorRequest.from_dict(obj.get("bellSchedule")) if obj.get("bellSchedule") is not None else None,
            "start_period": Int32LocatorRequest.from_dict(obj.get("startPeriod")) if obj.get("startPeriod") is not None else None,
            "end_period": Int32LocatorRequest.from_dict(obj.get("endPeriod")) if obj.get("endPeriod") is not None else None,
            "periods_not_needing_replacement": [Int32LocatorRequest.from_dict(_item) for _item in obj.get("periodsNotNeedingReplacement")] if obj.get("periodsNotNeedingReplacement") is not None else None,
            "standard_custom_schedule_variant": PositionScheduleCustomVariantRequest.from_dict(obj.get("standardCustomScheduleVariant")) if obj.get("standardCustomScheduleVariant") is not None else None,
            "additional_custom_schedule_variants": [PositionScheduleCustomVariantRequest.from_dict(_item) for _item in obj.get("additionalCustomScheduleVariants")] if obj.get("additionalCustomScheduleVariants") is not None else None
        })
        return _obj


