# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr
from redrover_api.models.int32_id_name_class import Int32IdNameClass

class SimplePerson(BaseModel):
    """
    User  # noqa: E501
    """
    id: Optional[StrictInt] = Field(None, description="Red Rover internal id of the user")
    external_id: Optional[StrictStr] = Field(None, alias="externalId", description="External Id of the user")
    secondary_identifier: Optional[StrictStr] = Field(None, alias="secondaryIdentifier", description="Secondary Identifier of the user")
    first_name: Optional[StrictStr] = Field(None, alias="firstName", description="User's first name")
    middle_name: Optional[StrictStr] = Field(None, alias="middleName", description="User's middle name")
    last_name: Optional[StrictStr] = Field(None, alias="lastName", description="User's last name")
    source_organization: Optional[Int32IdNameClass] = Field(None, alias="sourceOrganization")
    __properties = ["id", "externalId", "secondaryIdentifier", "firstName", "middleName", "lastName", "sourceOrganization"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SimplePerson:
        """Create an instance of SimplePerson from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of source_organization
        if self.source_organization:
            _dict['sourceOrganization'] = self.source_organization.to_dict()
        # set to None if external_id (nullable) is None
        # and __fields_set__ contains the field
        if self.external_id is None and "external_id" in self.__fields_set__:
            _dict['externalId'] = None

        # set to None if secondary_identifier (nullable) is None
        # and __fields_set__ contains the field
        if self.secondary_identifier is None and "secondary_identifier" in self.__fields_set__:
            _dict['secondaryIdentifier'] = None

        # set to None if first_name (nullable) is None
        # and __fields_set__ contains the field
        if self.first_name is None and "first_name" in self.__fields_set__:
            _dict['firstName'] = None

        # set to None if middle_name (nullable) is None
        # and __fields_set__ contains the field
        if self.middle_name is None and "middle_name" in self.__fields_set__:
            _dict['middleName'] = None

        # set to None if last_name (nullable) is None
        # and __fields_set__ contains the field
        if self.last_name is None and "last_name" in self.__fields_set__:
            _dict['lastName'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SimplePerson:
        """Create an instance of SimplePerson from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SimplePerson.parse_obj(obj)

        _obj = SimplePerson.parse_obj({
            "id": obj.get("id"),
            "external_id": obj.get("externalId"),
            "secondary_identifier": obj.get("secondaryIdentifier"),
            "first_name": obj.get("firstName"),
            "middle_name": obj.get("middleName"),
            "last_name": obj.get("lastName"),
            "source_organization": Int32IdNameClass.from_dict(obj.get("sourceOrganization")) if obj.get("sourceOrganization") is not None else None
        })
        return _obj


